//----------------------------------------------------------------------//
// NyanFi																//
//  GIFrA[															//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <algorithm>
#include <memory>
#include <Vcl.Imaging.GIFImg.hpp>
#include "Global.h"
#include "UserMdl.h"
#include "GifView.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGifViewer *GifViewer;

//---------------------------------------------------------------------------
__fastcall TGifViewer::TGifViewer(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this);
	Color = IniFile->ReadColGen(_T("GifViewBgCol"),	col_bgImage);
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormClose(TObject *Sender, TCloseAction &Action)
{
	FileName = EmptyStr;
	Image1->Picture->Assign(NULL);

	IniFile->SavePosInfo(this);
	IniFile->WriteIntGen(_T("GifViewBgCol"),	(int)Color);
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::WmSysCommand(TWMSysCommand &SysCom)
{
	//[~]{^ꂽ
	if (SysCom.CmdType==SC_CLOSE) {
		Close();
		ShowGifViewer = false;
	}
	else TForm::Dispatch(&SysCom);
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormResize(TObject *Sender)
{
	if (FileName.IsEmpty()) return;

	int iw = Image1->Picture->Width;
	int ih = Image1->Picture->Height;
	if (iw==0 || ih==0) return;

	float r;
	int vw = ClientWidth;
	int vh = ClientHeight;
	bool v_is_v = (vh>vw);
	bool i_is_v = (ih>iw);
	if ((v_is_v && i_is_v) || (!v_is_v && !i_is_v))
		//c֌W
		r = std::max(std::min(1.0 * vw/ih, 1.0 * vh/iw), std::min(1.0 * vw/iw, 1.0 * vh/ih));
	else
		//c֌WႤ
		r = std::min(std::min(1.0 * vw/ih, 1.0 * vh/iw), std::min(1.0 * vw/iw, 1.0 * vh/ih));
	if (r>1.0) r = 1.0;

	Image1->Align	= alClient;
	Image1->Center	= true;
	Image1->Stretch = false;
	if (r<1.0) {
		Image1->Align	= alNone;
		Image1->Width	= iw * r;
		Image1->Height	= ih * r;
		Image1->Left	= (vw - Image1->Width) / 2;
		Image1->Top 	= (vh - Image1->Height) / 2;
		Image1->Stretch = true;
	}
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::DrawImage(UnicodeString fnam)
{
	try {
		if (!test_GifExt(ExtractFileExt(fnam)) || !file_exists(fnam)) Abort();

		std::unique_ptr<TGIFImage> gif_buf(new TGIFImage());
		gif_buf->LoadFromFile(fnam);
		gif_buf->Animate	 = true;
		gif_buf->Transparent = true;
		Image1->Picture->Assign(gif_buf.get());
		Image1->Visible = true;
		FileName = fnam;
		FormResize(NULL);
	}
	catch (...) {
		Image1->Visible = false;
		FileName = EmptyStr;
	}
}

//---------------------------------------------------------------------------
void __fastcall TGifViewer::Image1Click(TObject *Sender)
{
	Application->MainForm->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGifViewer::FormClick(TObject *Sender)
{
	Application->MainForm->SetFocus();
}

//---------------------------------------------------------------------------
//wiFݒ
//---------------------------------------------------------------------------
void __fastcall TGifViewer::BgColItemClick(TObject *Sender)
{
	UserModule->ColorDlg->Color = Color;
	if (UserModule->ColorDlg->Execute()) {
		Color = UserModule->ColorDlg->Color;
		DrawImage(FileName);
	}
	Application->MainForm->SetFocus();
}
//---------------------------------------------------------------------------
